unit IpDataLib_TLB;
// ************************************************************************  //
// Type Lib: IpDataLib.dll (1)
// LIBID: {17D4B196-3F7F-4BB6-B526-B8BCFFCA6895}
// LCID: 0
// Helpfile: 
// HelpString: SkyGz IpDataLib 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\STDOLE2.TLB)
// Errors:
//   Error creating palette bitmap of (TIpData) : Server IpDataLib.dll contains no icons
// ************************************************************************ //

{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  IpDataLibMajorVersion = 1;
  IpDataLibMinorVersion = 0;

  LIBID_IpDataLib: TGUID = '{17D4B196-3F7F-4BB6-B526-B8BCFFCA6895}';

  IID__IpData: TGUID = '{3167ABE7-78EC-42E4-9782-A94062AB0037}';
  DIID___IpData: TGUID = '{5485FFFD-8A7F-4196-9D9E-C0B641A286F7}';
  CLASS_IpData: TGUID = '{CD6D58CE-CC45-40C7-86C6-B1B6723401A5}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum StyleFormat_Enum
type
  StyleFormat_Enum = TOleEnum;
const
  Country = $00000001;
  CountryAndCity = $00000002;
  City = $00000003;

// Constants for enum SaveFormat_Enum
type
  SaveFormat_Enum = TOleEnum;
const
  sf_Str = $00000001;
  sf_Num = $00000002;

// Constants for enum SaveType_Enum
type
  SaveType_Enum = TOleEnum;
const
  st_Txt = $00000001;
  st_Mdb = $00000002;
  St_Xls = $00000003;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  _IpData = interface;
  _IpDataDisp = dispinterface;
  __IpData = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  IpData = _IpData;


// *********************************************************************//
// Interface: _IpData
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {3167ABE7-78EC-42E4-9782-A94062AB0037}
// *********************************************************************//
  _IpData = interface(IDispatch)
    ['{3167ABE7-78EC-42E4-9782-A94062AB0037}']
    function Get_Version: WideString; safecall;
    function Get_FileName: WideString; safecall;
    procedure Set_FileName(const Param1: WideString); safecall;
    function Get_Style: StyleFormat_Enum; safecall;
    procedure Set_Style(Param1: StyleFormat_Enum); safecall;
    function Get_Count: Integer; safecall;
    procedure StopConvert; safecall;
    function Get_Position: Integer; safecall;
    function GetAddr(const IpAddress: WideString): WideString; safecall;
    function ConvertIpData(OneSelfDispose: WordBool; const ReplaceStr: WideString; 
                           const SavePath: WideString; Separator: Smallint; 
                           var SaveFormat: SaveFormat_Enum; SaveType: SaveType_Enum): WordBool; safecall;
    function TableExists(const DbFile: WideString; const Table: WideString): WordBool; safecall;
    property Version: WideString read Get_Version;
    property FileName: WideString read Get_FileName write Set_FileName;
    property Style: StyleFormat_Enum read Get_Style write Set_Style;
    property Count: Integer read Get_Count;
    property Position: Integer read Get_Position;
  end;

// *********************************************************************//
// DispIntf:  _IpDataDisp
// Flags:     (4560) Hidden Dual NonExtensible OleAutomation Dispatchable
// GUID:      {3167ABE7-78EC-42E4-9782-A94062AB0037}
// *********************************************************************//
  _IpDataDisp = dispinterface
    ['{3167ABE7-78EC-42E4-9782-A94062AB0037}']
    property Version: WideString readonly dispid 1745027076;
    property FileName: WideString dispid 1745027075;
    property Style: StyleFormat_Enum dispid 1745027074;
    property Count: Integer readonly dispid 1745027073;
    procedure StopConvert; dispid 1610809349;
    property Position: Integer readonly dispid 1745027072;
    function GetAddr(const IpAddress: WideString): WideString; dispid 1610809350;
    function ConvertIpData(OneSelfDispose: WordBool; const ReplaceStr: WideString; 
                           const SavePath: WideString; Separator: Smallint; 
                           var SaveFormat: SaveFormat_Enum; SaveType: SaveType_Enum): WordBool; dispid 1610809351;
    function TableExists(const DbFile: WideString; const Table: WideString): WordBool; dispid 1610809357;
  end;

// *********************************************************************//
// DispIntf:  __IpData
// Flags:     (4240) Hidden NonExtensible Dispatchable
// GUID:      {5485FFFD-8A7F-4196-9D9E-C0B641A286F7}
// *********************************************************************//
  __IpData = dispinterface
    ['{5485FFFD-8A7F-4196-9D9E-C0B641A286F7}']
    procedure OnGetData(Position: Integer; var StartIP: WideString; var EndIP: WideString; 
                        var Country: WideString; var Area: WideString); dispid 1;
  end;

// *********************************************************************//
// The Class CoIpData provides a Create and CreateRemote method to          
// create instances of the default interface _IpData exposed by              
// the CoClass IpData. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoIpData = class
    class function Create: _IpData;
    class function CreateRemote(const MachineName: string): _IpData;
  end;

  TIpDataOnGetData = procedure(ASender: TObject; Position: Integer; var StartIP: WideString; 
                                                 var EndIP: WideString; var Country: WideString; 
                                                 var Area: WideString) of object;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TIpData
// Help String      : 
// Default Interface: _IpData
// Def. Intf. DISP? : No
// Event   Interface: __IpData
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TIpDataProperties= class;
{$ENDIF}
  TIpData = class(TOleServer)
  private
    FOnGetData: TIpDataOnGetData;
    FIntf:        _IpData;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TIpDataProperties;
    function      GetServerProperties: TIpDataProperties;
{$ENDIF}
    function      GetDefaultInterface: _IpData;
  protected
    procedure InitServerData; override;
    procedure InvokeEvent(DispID: TDispID; var Params: TVariantArray); override;
    function Get_Version: WideString;
    function Get_FileName: WideString;
    procedure Set_FileName(const Param1: WideString);
    function Get_Style: StyleFormat_Enum;
    procedure Set_Style(Param1: StyleFormat_Enum);
    function Get_Count: Integer;
    function Get_Position: Integer;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: _IpData);
    procedure Disconnect; override;
    procedure StopConvert;
    function GetAddr(const IpAddress: WideString): WideString;
    function ConvertIpData(OneSelfDispose: WordBool; const ReplaceStr: WideString; 
                           const SavePath: WideString; Separator: Smallint; 
                           var SaveFormat: SaveFormat_Enum; SaveType: SaveType_Enum): WordBool;
    function TableExists(const DbFile: WideString; const Table: WideString): WordBool;
    property DefaultInterface: _IpData read GetDefaultInterface;
    property Version: WideString read Get_Version;
    property Count: Integer read Get_Count;
    property Position: Integer read Get_Position;
    property FileName: WideString read Get_FileName write Set_FileName;
    property Style: StyleFormat_Enum read Get_Style write Set_Style;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TIpDataProperties read GetServerProperties;
{$ENDIF}
    property OnGetData: TIpDataOnGetData read FOnGetData write FOnGetData;
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TIpData
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TIpDataProperties = class(TPersistent)
  private
    FServer:    TIpData;
    function    GetDefaultInterface: _IpData;
    constructor Create(AServer: TIpData);
  protected
    function Get_Version: WideString;
    function Get_FileName: WideString;
    procedure Set_FileName(const Param1: WideString);
    function Get_Style: StyleFormat_Enum;
    procedure Set_Style(Param1: StyleFormat_Enum);
    function Get_Count: Integer;
    function Get_Position: Integer;
  public
    property DefaultInterface: _IpData read GetDefaultInterface;
  published
    property FileName: WideString read Get_FileName write Set_FileName;
    property Style: StyleFormat_Enum read Get_Style write Set_Style;
  end;
{$ENDIF}


procedure Register;

resourcestring
  dtlServerPage = 'SkyGz';

  dtlOcxPage = 'SkyGz';

implementation

uses ComObj;

class function CoIpData.Create: _IpData;
begin
  Result := CreateComObject(CLASS_IpData) as _IpData;
end;

class function CoIpData.CreateRemote(const MachineName: string): _IpData;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_IpData) as _IpData;
end;

procedure TIpData.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{CD6D58CE-CC45-40C7-86C6-B1B6723401A5}';
    IntfIID:   '{3167ABE7-78EC-42E4-9782-A94062AB0037}';
    EventIID:  '{5485FFFD-8A7F-4196-9D9E-C0B641A286F7}';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TIpData.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    ConnectEvents(punk);
    Fintf:= punk as _IpData;
  end;
end;

procedure TIpData.ConnectTo(svrIntf: _IpData);
begin
  Disconnect;
  FIntf := svrIntf;
  ConnectEvents(FIntf);
end;

procedure TIpData.DisConnect;
begin
  if Fintf <> nil then
  begin
    DisconnectEvents(FIntf);
    FIntf := nil;
  end;
end;

function TIpData.GetDefaultInterface: _IpData;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TIpData.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TIpDataProperties.Create(Self);
{$ENDIF}
end;

destructor TIpData.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TIpData.GetServerProperties: TIpDataProperties;
begin
  Result := FProps;
end;
{$ENDIF}

procedure TIpData.InvokeEvent(DispID: TDispID; var Params: TVariantArray);
begin
  case DispID of
    -1: Exit;  // DISPID_UNKNOWN
    1: if Assigned(FOnGetData) then
         FOnGetData(Self,
                    Params[0] {Integer},
                    WideString((TVarData(Params[1]).VPointer)^) {var WideString},
                    WideString((TVarData(Params[2]).VPointer)^) {var WideString},
                    WideString((TVarData(Params[3]).VPointer)^) {var WideString},
                    WideString((TVarData(Params[4]).VPointer)^) {var WideString});
  end; {case DispID}
end;

function TIpData.Get_Version: WideString;
begin
    Result := DefaultInterface.Version;
end;

function TIpData.Get_FileName: WideString;
begin
    Result := DefaultInterface.FileName;
end;

procedure TIpData.Set_FileName(const Param1: WideString);
  { Warning: The property FileName has a setter and a getter whose
    types do not match. Delphi was unable to generate a property of
    this sort and so is using a Variant as a passthrough. }
var
  InterfaceVariant: OleVariant;
begin
  InterfaceVariant := DefaultInterface;
  InterfaceVariant.FileName := Param1;
end;

function TIpData.Get_Style: StyleFormat_Enum;
begin
    Result := DefaultInterface.Style;
end;

procedure TIpData.Set_Style(Param1: StyleFormat_Enum);
begin
  DefaultInterface.Set_Style(Param1);
end;

function TIpData.Get_Count: Integer;
begin
    Result := DefaultInterface.Count;
end;

function TIpData.Get_Position: Integer;
begin
    Result := DefaultInterface.Position;
end;

procedure TIpData.StopConvert;
begin
  DefaultInterface.StopConvert;
end;

function TIpData.GetAddr(const IpAddress: WideString): WideString;
begin
  Result := DefaultInterface.GetAddr(IpAddress);
end;

function TIpData.ConvertIpData(OneSelfDispose: WordBool; const ReplaceStr: WideString; 
                               const SavePath: WideString; Separator: Smallint; 
                               var SaveFormat: SaveFormat_Enum; SaveType: SaveType_Enum): WordBool;
begin
  Result := DefaultInterface.ConvertIpData(OneSelfDispose, ReplaceStr, SavePath, Separator, 
                                           SaveFormat, SaveType);
end;

function TIpData.TableExists(const DbFile: WideString; const Table: WideString): WordBool;
begin
  Result := DefaultInterface.TableExists(DbFile, Table);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TIpDataProperties.Create(AServer: TIpData);
begin
  inherited Create;
  FServer := AServer;
end;

function TIpDataProperties.GetDefaultInterface: _IpData;
begin
  Result := FServer.DefaultInterface;
end;

function TIpDataProperties.Get_Version: WideString;
begin
    Result := DefaultInterface.Version;
end;

function TIpDataProperties.Get_FileName: WideString;
begin
    Result := DefaultInterface.FileName;
end;

procedure TIpDataProperties.Set_FileName(const Param1: WideString);
  { Warning: The property FileName has a setter and a getter whose
    types do not match. Delphi was unable to generate a property of
    this sort and so is using a Variant as a passthrough. }
var
  InterfaceVariant: OleVariant;
begin
  InterfaceVariant := DefaultInterface;
  InterfaceVariant.FileName := Param1;
end;

function TIpDataProperties.Get_Style: StyleFormat_Enum;
begin
    Result := DefaultInterface.Style;
end;

procedure TIpDataProperties.Set_Style(Param1: StyleFormat_Enum);
begin
  DefaultInterface.Set_Style(Param1);
end;

function TIpDataProperties.Get_Count: Integer;
begin
    Result := DefaultInterface.Count;
end;

function TIpDataProperties.Get_Position: Integer;
begin
    Result := DefaultInterface.Position;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents(dtlServerPage, [TIpData]);
end;

end.
